//
//  MembershipEditingViewController.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/21/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit
import RxCocoa
import RxSwift
import RxDataSources

protocol MembershipEditingPresenterInterface: PresenterInterface {
    var addMembershipTrigger: PublishRelay<Membership> { get }
}

final class MembershipEditingViewController: UIViewController, MembershipEditingViewInterface {
    
    @IBOutlet weak var tableView: UITableView!
    // MARK: - Public properties -
    
    let viewModels = BehaviorRelay<[MembershipEditingCellType]>(value: [])
    let membership = BehaviorRelay<Membership?>(value: nil)
    var presenter: MembershipEditingPresenterInterface!
    
    // MARK: - Private properties -
    private let viewDidLoadRelay = BehaviorRelay(value: false)
    private let disposeBag = DisposeBag()
    private lazy var dataSource = makeDataSource()
    
    //  MARK: - Internal relays -
    private let membershipAvatarAssetIdRelay = PublishRelay<String>()
    private let membershipNameRelay = PublishRelay<String>()
    private let membershipPhoneNumberRelay = PublishRelay<String>()
    private let membershipAddressRelay = PublishRelay<String>()
    
    private let addMembershipRelay = PublishRelay<Void>()
    
    // MARK: - Lifecycle -
    override func viewDidLoad() {
        super.viewDidLoad()
        defer {
            viewDidLoadRelay.accept(true)
        }
        
        configureViews()
        configurePresenter()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        setupNavigation()
    }
    
    private func setupNavigation() {
        navigationItem.title = "Thêm thành viên mới"
    }
}

extension MembershipEditingViewController {
    private func configureViews() {
        configureTableView()
        
        let membershipInfoObservable = Observable
            .combineLatest(
                membershipAvatarAssetIdRelay,
                membershipNameRelay,
                membershipPhoneNumberRelay,
                membershipAddressRelay
            )
            .map { avatarAssetId, name, phoneNumber, address -> Membership in
                return Membership(
                    id: 0,
                    name: name,
                    gender: .female,
                    phoneNumber: phoneNumber,
                    avatarSavedAssetId: avatarAssetId,
                    address: address
                )
            }
        
        addMembershipRelay
            .withLatestFrom(membershipInfoObservable)
            .subscribeNext{[weak presenter] membership in
                presenter?.addMembershipTrigger.accept(membership)
            }
            .disposed(by: disposeBag)
    }
    
    private func configureTableView() {
        tableView.register(cellType: MembershipEditingChooseImageCell.self)
        tableView.register(cellType: MembershipEditingInfoCell.self)
        tableView.register(cellType: MembershipEditingAddMemberCell.self)
    }
}

extension MembershipEditingViewController {
    private func configurePresenter() {
        let didLoad = viewDidLoadRelay.asObservable()
        viewModels
            .filterEmpty()
            .takeLatestWhen(didLoad)
            .map { [ Section(model: 0, items: $0)] }
            .asDriver(onErrorDriveWith: .never())
            .drive(tableView.rx.items(dataSource: dataSource))
            .disposed(by: disposeBag)
        
        membership
            .filterNil()
            .takeLatestWhen(didLoad)
            .subscribeNext { [weak self] membership in
                self?.membershipAvatarAssetIdRelay.accept(membership.avatarSavedAssetId)
                self?.membershipNameRelay.accept(membership.name)
                self?.membershipPhoneNumberRelay.accept(membership.phoneNumber)
                self?.membershipAddressRelay.accept(membership.address)
            }
            .disposed(by: disposeBag)
    }
}

// MARK: - Extensions -

enum MembershipEditingInfoTextFieldTag: Int {
    case membershipName = 1
    case membershipPhoneNumber = 2
    case membershipAddress = 3
}
enum MembershipEditingCellType {
    case chooseImage(title: String, initAssetId: String)
    case info(title: String, initTitle: String, style: DSInfoTextFieldView.Style, tag: MembershipEditingInfoTextFieldTag)
    case add(title: String)
}

extension MembershipEditingViewController {
    typealias Section = SectionModel<Int, MembershipEditingCellType>
    typealias DataSource = RxTableViewSectionedReloadDataSource<Section>
}

extension MembershipEditingViewController {
    private func makeDataSource() -> DataSource {
        return DataSource { (_, tableView, indexPath, cellType) -> UITableViewCell in
            switch cellType {
            case let .chooseImage(title, initAssetId):
                let cell: MembershipEditingChooseImageCell = tableView.dequeueReusableCell(for: indexPath)
                cell.didChangeImage = { [weak self] image in
                    self?.saveMembershipImage(image)
                }
                cell.configureCell(title: title, presentViewController: self, initAssetId: initAssetId)
                return cell
                
            case let .info(title, initContent, style, tag):
                let cell: MembershipEditingInfoCell = tableView.dequeueReusableCell(for: indexPath)
                cell.configureCell(title: title, style: style, initContent: initContent)
                cell.didChangeContent = { [weak self] content in
                    switch tag {
                    case .membershipName:
                        self?.membershipNameRelay.accept(content)
                        
                    case .membershipPhoneNumber:
                        self?.membershipPhoneNumberRelay.accept(content)
                        
                    case .membershipAddress:
                        self?.membershipAddressRelay.accept(content)
                    }
                }
                return cell
                
            case let .add(title):
                let cell: MembershipEditingAddMemberCell = tableView.dequeueReusableCell(for: indexPath)
                cell.onAddMembership = { [weak self] in
                    self?.addMembershipRelay.accept(())
                }
                cell.configureCell(title: title)
                return cell
            }
        }
    }
    
    private func saveMembershipImage(_ image: UIImage) {
        PhotoWriter
            .save(image)
            .subscribe { savedAssetId in
                self.membershipAvatarAssetIdRelay.accept(savedAssetId)
            }
            .disposed(by: disposeBag)
    }
}
